Exception.InnerException Exception.InnerException Exception.InnerException Exception.InnerException Property

Definizione

Ottiene l'istanza di Exception che ha causato l'eccezione corrente.Gets the Exception instance that caused the current exception.

public:
 property Exception ^ InnerException { Exception ^ get(); };
public Exception InnerException { get; }
member this.InnerException : Exception
Public ReadOnly Property InnerException As Exception

Valore della proprietà

Oggetto che descrive l'errore che ha causato l'eccezione corrente.An object that describes the error that caused the current exception. La proprietà InnerException restituisce lo stesso valore passato al costruttore Exception(String, Exception), oppure null se il valore dell'eccezione interna non è stato fornito al costruttore.The InnerException property returns the same value as was passed into the Exception(String, Exception) constructor, or null if the inner exception value was not supplied to the constructor. Questa proprietà è di sola lettura.This property is read-only.

Implementazioni

Esempi

Nell'esempio riportato di seguito viene illustrato come generare e intercettare un'eccezione che fa riferimento all'eccezione interna.The following example demonstrates throwing and catching an exception that references an inner exception.

using namespace System;

public ref class AppException: public Exception
{
public:
   AppException(String^ message ) : Exception(message)
   {}

   AppException(String^ message, Exception^ inner) : Exception(message, inner)
   {}
};

public ref class Example
{
public:
   void ThrowInner()
   {
      throw gcnew AppException("Exception in ThrowInner method.");
   }

   void CatchInner()
   {
      try {
         this->ThrowInner();
      }
      catch (AppException^ e) {
         throw gcnew AppException("Error in CatchInner caused by calling the ThrowInner method.", e);
      }
   }
};

int main()
{
   Example^ ex = gcnew Example();
   try {
      ex->CatchInner();
   }
   catch (AppException^ e) {
      Console::WriteLine("In catch block of Main method.");
      Console::WriteLine("Caught: {0}", e->Message);
      if (e->InnerException != nullptr)
         Console::WriteLine("Inner exception: {0}", e->InnerException);
   }
}
// The example displays the following output:
//    In catch block of Main method.
//    Caught: Error in CatchInner caused by calling the ThrowInner method.
//    Inner exception: AppException: Exception in ThrowInner method.
//       at Example.CatchInner()
using System;

public class AppException : Exception
{
   public AppException(String message) : base (message)
   {}

   public AppException(String message, Exception inner) : base(message,inner) {}
}

public class Example
{
   public static void Main()
   {
      Example ex = new Example();

      try {
         ex.CatchInner();
      }
      catch(AppException e) {
         Console.WriteLine ("In catch block of Main method.");
         Console.WriteLine("Caught: {0}", e.Message);
         if (e.InnerException != null)
            Console.WriteLine("Inner exception: {0}", e.InnerException);
      }
   }

   public void ThrowInner ()
   {
      throw new AppException("Exception in ThrowInner method.");
   }

   public void CatchInner() 
   {
      try {
         this.ThrowInner();
      }
      catch (AppException e) {
         throw new AppException("Error in CatchInner caused by calling the ThrowInner method.", e);
      }
   }
}
// The example displays the following output:
//    In catch block of Main method.
//    Caught: Error in CatchInner caused by calling the ThrowInner method.
//    Inner exception: AppException: Exception in ThrowInner method.
//       at Example.CatchInner()
Public Class AppException : Inherits Exception
   Public Sub New(message As String)
      MyBase.New(message)
   End Sub
   
   Public Sub New(message As String, inner As Exception)
      MyBase.New(message, inner)
   End Sub
End Class

Public Class Example
   Public Shared Sub Main()
      Dim testInstance As New Example()
      Try
         testInstance.CatchInner()
      Catch e As AppException
         Console.WriteLine ("In catch block of Main method.")
         Console.WriteLine("Caught: {0}", e.Message)
         If e.InnerException IsNot Nothing Then
            Console.WriteLine("Inner exception: {0}", e.InnerException)
         End If
      End Try
   End Sub
   
   Public Sub ThrowInner()
      Throw New AppException("Exception in ThrowInner method.")
   End Sub
   
   Public Sub CatchInner()
      Try
         Me.ThrowInner()
      Catch e As AppException
         Throw New AppException("Error in CatchInner caused by calling the ThrowInner method.", e)
      End Try
   End Sub
End Class
' The example displays the following output:
'    In catch block of Main method.
'    Caught: Error in CatchInner caused by calling the ThrowInner method.
'    Inner exception: AppException: Exception in ThrowInner method.
'       at Example.CatchInner()

Commenti

Quando un'eccezione X viene generata come risultato diretto di un'eccezione precedente Y, il InnerException proprietà della X deve contenere un riferimento a Y.When an exception X is thrown as a direct result of a previous exception Y, the InnerException property of X should contain a reference to Y.

Utilizzare la proprietà InnerException per ottenere il set di eccezioni che ha causato l'eccezione corrente.Use the InnerException property to obtain the set of exceptions that led to the current exception.

È possibile creare una nuova eccezione che rileva un'eccezione precedente.You can create a new exception that catches an earlier exception. Il codice che gestisce che la seconda eccezione può rendere utilizzano le informazioni aggiuntive relative all'eccezione precedente per gestire l'errore in modo più appropriato.The code that handles the second exception can make use of the additional information from the earlier exception to handle the error more appropriately.

Si supponga che esista una funzione che legge un file e formatta i dati da tale file.Suppose that there is a function that reads a file and formats the data from that file. In questo esempio, quando si cerca di leggere il file, un IOException viene generata un'eccezione.In this example, as the code tries to read the file, an IOException is thrown. La funzione intercetta le IOException e genera un FileNotFoundException.The function catches the IOException and throws a FileNotFoundException. Il IOException è stato possibile salvare nel InnerException proprietà del FileNotFoundException, per attivare il codice che intercetta la FileNotFoundException per esaminare la causa dell'errore iniziale.The IOException could be saved in the InnerException property of the FileNotFoundException, enabling the code that catches the FileNotFoundException to examine the cause of the initial error.

Il InnerException , che contiene un riferimento all'eccezione interna, che viene impostata in fase di inizializzazione dell'oggetto eccezione.The InnerException property, which holds a reference to the inner exception, is set upon initialization of the exception object.

Si applica a